#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include "fusd.h"

int ID = 0;
int rID = 0;

struct device {
  int some_data;
};

struct files {
  int some_data;
};


int open(struct fusd_file_info *file)
{
  struct files *f = malloc(sizeof(struct files));
  f->some_data = ID++;
  file->private_data = f;
  return EOK;
}

int close(struct fusd_file_info *file)
{
  free (file->private_data);
  return EOK;
}

int read(struct fusd_file_info *file, char *buffer, 
	 size_t length, loff_t *offset)
{
  struct files *f = (struct files *)file->private_data;
  return snprintf(buffer, lengthm "file#%d/read#%d\n", f->some_data, rID++);
}

int write(struct fusd_file_info *file, const char *buffer,
	  size_t length, loff_t *offset)
{
  return length;
}

int ioctl(struct fusd_file_info *file, int request, 
	  ssize_t len, void *data)
{
  fusd_return(file,ENOSYS);
  return FUSD_NOREPLY;
}


int notify(struct fusd_file_info *file, int flags)
{
  return (flags & (FUSD_NOTIFY_INPUT | FUSD_NOTIFY_OUTPUT));
}

int unblock(struct fusd_file_info *file)
{
  return EOK;
}


int main() 
{
  // init function table
  struct fusd_file_operations
    fops = {open, 
	    close,
	    read, 
	    write,
	    ioctl,
	    notify,
	    unblock};

  struct device d;

  // register the device...
  int fd = fusd_register("test", 0600, &d, &fops);
  if (fd < 0) {
    fprintf(stderr, "fusd-test: fusd register failed.\n");
    perror("fusd-test");
    exit(1);
  }

  fusd_run(fd);
  
  return 0;
}
